/*  etseq Ա 
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#ifndef _ETSEQ_CTRL_APPEARED_
#define _ETSEQ_CTRL_APPEARED_
#include "cross.h"
#include <set>
#include "thread.h"
#include "trace.h"

namespace etseq
{

template <class Thread, class Configuration>
class etseq_app;

// 
template <class Thread, class Configuration,
    class OwnerType = etseq_app<Thread, Configuration> >
class etseq_ctrl : public euc::thread
{
public:
    etseq_ctrl(unsigned port, OwnerType *owner);
    virtual ~etseq_ctrl(void);

public:
    //  true ͬ addr 
    //  false ɻؾ addr 
    bool connection_allowed(sockaddr_in *clientaddr, SOCKET connfd) const;
    // ˿ڣʼ
    bool initialize(void);
    // ִз
    virtual unsigned run(void);
    // ֹͣ
    void stop(void);
    // ̡߳úΪ̶߳ monitor У
    // 벻Ҫֱӵá
    //  monitor ϸͣο euc::thread::thread(...)
    static void kill_it(euc::thread *addr, void *self);

private:
    volatile bool _working;
    std::set<Thread *> threads;
    IMPLEMENT_SYNCHRONIZATION(_sync);
    SOCKET listenfd;
    OwnerType *_owner;
    unsigned localport;
};

template <class Thread, class Configuration, class OwnerType>
etseq_ctrl<Thread, Configuration, OwnerType>::etseq_ctrl
    (unsigned port, OwnerType *owner)
    : _owner(owner), localport(port)
{}

template <class Thread, class Configuration, class OwnerType>
etseq_ctrl<Thread, Configuration, OwnerType>::~etseq_ctrl(void)
{}

template <class Thread, class Configuration, class OwnerType>
bool etseq_ctrl<Thread, Configuration, OwnerType>::connection_allowed
    (sockaddr_in *clientaddr, SOCKET connfd) const
{
    return _owner->connection_allowed(clientaddr, connfd);
}

template <class Thread, class Configuration, class OwnerType>
bool etseq_ctrl<Thread, Configuration, OwnerType>::initialize(void)
{
    sockaddr_in servaddr;

    assert(localport != 0);
    trace("Listening on port %d\n", localport);

    listenfd = socket(AF_INET, SOCK_STREAM, 0);
    if(listenfd == INVALID_SOCKET)
        return false;

    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family      = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port        = htons(localport);

    if (bind(listenfd, (sockaddr *) &servaddr, sizeof(servaddr)) != 0
        || listen(listenfd, 0) != 0)
    {
        closesocket(listenfd);
        return false;
    }

    return true;
}

template <class Thread, class Configuration, class OwnerType>
unsigned etseq_ctrl<Thread, Configuration, OwnerType>::run(void)
{
    _working = true;
    while (_working)
    {
        socklen_t sock_size = sizeof(sockaddr_in);
        sockaddr_in clientaddr;
        SOCKET connfd
            = accept(listenfd, (struct sockaddr *) &clientaddr,
            &sock_size);

        if (connfd == INVALID_SOCKET)
            continue;

        if (!connection_allowed(&clientaddr, connfd))
        {
            shutdown(connfd, SD_BOTH);
            closesocket(connfd);
            continue;
        }

        Thread *thread = new Thread(connfd, clientaddr, kill_it,
            (void *) this);
        thread->start();

        BEGIN_SYNCHRONIZATION(_sync);
        threads.insert(thread);
        END_SYNCHRONIZATION(_sync);
    }

    typename std::set<Thread *>::size_type thread_count;

    // ֹеķ߳
    trace("Sending stop query to all working threads");
    BEGIN_SYNCHRONIZATION(_sync);
    typename std::set<Thread *>::iterator ite;
    for (ite = threads.begin(); ite != threads.end(); ++ite)
    {
        trace(".");
        (**ite).stop();
    }
    trace("\n");
    END_SYNCHRONIZATION(_sync);
    trace("Done! Waiting threads to die . . .\n");

    do
    {
        BEGIN_SYNCHRONIZATION(_sync);
        thread_count = threads.size();
        END_SYNCHRONIZATION(_sync);

        if (thread_count > 0)
        {
#if defined(UNIX) || defined(LINUX)
            sleep(1);
#else
            Sleep(1000);
#endif
        }
    }
    while (thread_count);

    trace("Stopping server . . .\n");
    stop();

    return true;
}

template <class Thread, class Configuration, class OwnerType>
void etseq_ctrl<Thread, Configuration, OwnerType>::stop(void)
{
    _working = false;
    shutdown(listenfd, SD_BOTH);
    closesocket(listenfd);
}

template <class Thread, class Configuration, class OwnerType>
void etseq_ctrl<Thread, Configuration, OwnerType>::kill_it
    (euc::thread *addr, void *self)
{
    SYNCHRONIZED(((etseq_ctrl *) self)->_sync);
    ((etseq_ctrl *) self)->threads.erase((Thread *) addr);
    delete addr;
    trace("A user left!\n");
}

} //namespace

#endif
