/*  etseq Ա ߳
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include <sstream>
#include "etseq_app.h"
#include "etseq_srv.h"

namespace etseq
{

etseq_srv::etseq_srv(SOCKET sock, sockaddr_in addr,
                     void (*monitor)(euc::thread *addr, void *param),
                     void *param)
                     : euc::thread(monitor, param),
                     _sock(sock), _addr(addr)

{
    SYNCHRONIZED(_etseq_lock);
#if defined(UNIX) || defined(LINUX)
    signal(SIGPIPE, broken_pipe);
#endif
}

etseq_srv::~etseq_srv(void)
{
    SYNCHRONIZED(_etseq_lock);
}

std::string etseq_srv::get_address_string(bool port) const
{
    std::stringstream out;
    out << (int) (((unsigned char *) &_addr.sin_addr)[0]) << "."
        << (int) (((unsigned char *) &_addr.sin_addr)[1]) << "."
        << (int) (((unsigned char *) &_addr.sin_addr)[2]) << "."
        << (int) (((unsigned char *) &_addr.sin_addr)[3]);

    if (port)
        out << ":" << ntohs(_addr.sin_port);

    return out.str();
}

bool etseq_srv::write(const void *const buffer, size_t size)
{
    if (size)
    {
        int result
            = completely_send(_sock, (const char *) buffer, (int) size, 0);

        if (result == SOCKET_ERROR)
        {
            shutdown(_sock, SD_BOTH);
            closesocket(_sock);
            _sock = INVALID_SOCKET;
        }

        return ((unsigned int) result)  == size;
    }
    return true;
}

bool etseq_srv::write_string(const std::string content)
{
    return write(content.c_str(), (size_t) content.size());
}

bool etseq_srv::write_string(const char *const content)
{
    return write(content, strlen(content));
}

unsigned etseq_srv::run(void)
{
    char buffer[4097];
    bool persist = false;

    write_string(welcome(&persist));
    if (!persist)
    {
        stop();
        return 0;
    }

    do
    {
        int pos = recv(_sock, buffer, 4096, 0);
        if (pos < 1)
            break;
        write_string(parse(std::string(buffer, pos), &persist));
    }
    while (persist);

    BEGIN_SYNCHRONIZATION(_etseq_lock);
    if (_sock != INVALID_SOCKET)
        stop();
    END_SYNCHRONIZATION(_etseq_lock);

    return 0;
}

void etseq_srv::stop(void)
{
    SYNCHRONIZED(_etseq_lock);
    write_string(bye());
    shutdown(_sock, SD_BOTH);
    closesocket(_sock);
    _sock = INVALID_SOCKET;
}

unsigned etseq_srv::get_default_port(void)
{
    return 12074;
}

unsigned etseq_srv::max_line_size(void)
{
    return 4096;
}

std::string etseq_srv::welcome(bool *result)
{
    SYNCHRONIZED(_etseq_lock);
    if (result)
        *result = true;
    return std::string();
}

std::string etseq_srv::poured(bool *result)
{
    SYNCHRONIZED(_etseq_lock);
    if (result)
        *result = false;
    return std::string();
}

std::string etseq_srv::parse(std::string question, bool *result)
{
    SYNCHRONIZED(_etseq_lock);
    if (result)
        *result = true;

    unsigned max_size = max_line_size();
    _input_buffer += question;
    std::string::size_type pos;

    std::string answer;
    std::string to_send;

    while ((pos = _input_buffer.find('\n')) != std::string::npos)
    {
        if (pos > 0)
        {
            if (_input_buffer[pos - 1] == '\r')
            {
                if (max_size != 0
                    && (pos - 1) > (std::string::size_type) max_size)
                    return poured(result);

                to_send = _input_buffer.substr(0, pos - 1);
            }
            else
            {
                if (max_size != 0
                    && pos > (std::string::size_type) max_size)
                    return poured(result);

                to_send = _input_buffer.substr(0, pos);
            }
        }

        if (pos < _input_buffer.size() - 1)
            _input_buffer = _input_buffer.substr(pos + 1);
        else
            _input_buffer = "";

        if (pos > 0)
        {
            answer += parse_line(to_send, result);
            if (result)
                if (*result == false)
                    return answer;
        }
    }

    if (max_size != 0
        && _input_buffer.size() > (std::string::size_type) max_size)
        return poured(result);

    return answer;
}

std::string etseq_srv::parse_line(std::string line, bool *result)
{
    if (result)
        *result = false;
    return std::string();
}

std::string etseq_srv::bye(void)
{
    SYNCHRONIZED(_etseq_lock);
    return std::string();
}

const std::string &etseq_srv::get_buffer(void)
{
    return _input_buffer;
}

} //namespace
